<?php

namespace Drp\LdapAuthentication;

/**
 * Interface DrpLdapUser
 * @package Drp\LdapAuthentication
 */
interface DrpLdapUser
{

    /**
     * Set the ldap_user flag
     * @param $value The value to set the flag as
     * @return null
     */
    public function setLdapUser($value);

    /**
     * Set the explicit_access flag
     * @param $value The value to set the flag as
     * @return null
     */
    public function setExplicitAccess($value);

    /**
     * Return if the user is an ldap user
     * @return boolean
     */
    public function isLdapUser();

    /**
     * return if the user has explicit access
     * @return boolean
     */
    public function isExplicitLdapUser();

    /**
     * return if the user has group access
     * @return boolean
     */
    public function isGroupLdapUser();
}
