<?php

namespace Drp\LdapAuthentication\Testing\Concerns;

use Drp\LdapAuthentication\GroupFinder;
use Drp\LdapAuthentication\Testing\Fakes\AdLdapUser;
use Drp\LdapAuthentication\Testing\Fakes\DrpldapAuthUserProvider;

trait InteractsWithLdap
{
    /**
     * Mock the Ldap User provider so we don't hit LDAP
     *
     * @param null $user
     */
    protected function mockLdapLookup($user = null)
    {
        app('auth')->provider('ldap', function ($app, array $config) use ($user) {
            return (new DrpldapAuthUserProvider($app['hash'], $config['model'], $app[GroupFinder::class]))
                ->setAuthenticated($user);
        });
    }

    /**
     * Create a fake Ldap user with the given attributes
     * and return this as the authenticated user
     *
     * @param array $attributes
     * @param array $groups
     */
    protected function authenticateLdapUser(array $attributes = [], array $groups = [])
    {
        $ldapUser = new AdLdapUser($attributes, $groups);

        $this->mockLdapLookup($ldapUser);
    }
}
