<?php

namespace Drp\LdapAuthentication\Testing\Fakes;

/**
 * Class AdLdapUser
 * @package Drp\LdapAuthentication\Testing\Fakes
 */
class AdLdapUser extends \Adldap\Models\User
{
    /**
     * @var array
     */
    private $groups = [];

    /**
     * Constructor.
     *
     * @param array $attributes
     */
    public function __construct(array $attributes, array $groups = [])
    {
        $this->attributes = $attributes;
        $this->groups = array_flip($groups);
    }

    /**
     * @SuppressWarnings("unused")
     * @SuppressWarnings("BooleanArgumentFlag")
     *
     * Determine if the current model is a member of the specified group(s).
     * @param mixed $group
     * @param boolean $recursive
     *
     * @return bool
     */
    public function inGroup($group, $recursive = false)
    {
        return array_key_exists($group, $this->groups);
    }
}
