<?php

namespace Drp\LdapAuthentication\Testing\Fakes;

use Adldap\Models\User;

/**
 * Class DrpldapAuthUserProvider
 * @package Drp\LdapAuthentication\Testing\Fakes
 */
class DrpldapAuthUserProvider extends \Drp\LdapAuthentication\DrpldapAuthUserProvider
{
    /**
     * @var User|null
     */
    protected $user;

    /**
     * @param User $user
     * @return $this
     */
    public function setAuthenticated(User $user = null)
    {
        $this->user = $user;

        return $this;
    }

    /**
     * Authenticates against Active Directory using the specified credentials.
     *
     * @param array $credentials
     * @return \Adldap\Models\User|false
     * @SuppressWarnings(unused)
     */
    protected function authenticateWithCredentials(array $credentials = [])
    {
        if ($this->user instanceof User) {
            return $this->user;
        }
    }
}
