<?php

namespace  Drp\LdapAuthentication\Traits;

trait DrpLdapUserModelTrait
{
    /**
     * The Adldap User that is bound to the current model.
     * @var null|\Adldap\Models\User
     */
    public $adldapUser;

    /**
     * Set the ldap_user flag
     * @param $value The value to set the flag as
     * @return null
     */
    public function setLdapUser($value)
    {
        $this->ldap_user = $value;
    }

    /**
     * Set the explicit_access flag
     * @param $value The value to set the flag as
     * @return null
     */
    public function setExplicitAccess($value)
    {
        $this->explicit_access = $value;
    }

    /**
     * Return if the user is an ldap user
     * @return boolean
     */
    public function isLdapUser()
    {
        return $this->ldap_user;
    }

    /**
     * return if the user has explicit access
     * @return boolean
     */
    public function isExplicitLdapUser()
    {
        return $this->ldap_user && $this->explicit_access;
    }

    /**
     * return if the user has group access
     * @return boolean
     */
    public function isGroupLdapUser()
    {
        return $this->ldap_user && !$this->explicit_access;
    }
}
